   10 REM  Lawson Labs, Inc.                     Model 201 24-Bit Delta-Sigma Converter
   20 REM  3217 Phoenixville Pike                  Demonstration Code
   30 REM  Malvern, PA 19355
   40 REM  800 321-5355 or 610 725-8800                      January 6, 2017
   50 
      INSTALL @lib$ + "fnUSING.BBC"
      SPACES$ = "                                                                        "
      db%=0       :REM flag to block debug screen output, 1 to allow
   70 CLS
   80 CLOSE #0
  100 
      lun = OPENIN(@dir$ + "DRIVR201.CFG")
      zmodeREGHI% = VAL(GET$#lun TO 44)
      zmodeREGMID% = VAL(GET$#lun TO 44)
      zmodeREGLO% = VAL(GET$#lun TO 44)
      CHANNEL% = VAL(GET$#lun TO 44)
      FILTER% = VAL(GET$#lun TO 44)
      LOCAVERAGE% = VAL(GET$#lun)
      cr =BGET#lun
      EXTCCODE% = VAL(GET$#lun TO 44)
      BAUD% = VAL(GET$#lun TO 44)
      quote =BGET#lun
      COM$ = GET$#lun TO 34
      quote =BGET#lun
      INPBUF% = VAL(GET$#lun TO 44)
      NUMAVG% = VAL(GET$#lun TO 44)
      BU% = VAL(GET$#lun TO 44)
      GAIN% = VAL(GET$#lun TO 44)
      RATE = VAL(GET$#lun TO 44)
      WL% = VAL(GET$#lun)
      cr =BGET#lun
      DIM CHAN%(5)
      CHAN%(0) = VAL(GET$#lun TO 44)
      CHAN%(1) = VAL(GET$#lun TO 44)
      CHAN%(2) = VAL(GET$#lun TO 44)
      CHAN%(3) = VAL(GET$#lun TO 44)
      CHAN%(4) = VAL(GET$#lun TO 44)
      CHAN%(5) = VAL(GET$#lun)
      cr =BGET#lun
      MYSINGLECHAN% = VAL(GET$#lun)
      cr =BGET#lun
      SCAN% = VAL(GET$#lun TO 44)
      SCAN1% = VAL(GET$#lun TO 44)
      SCAN2% = VAL(GET$#lun TO 44)
      SCANINTERVAL# = VAL(GET$#lun TO 44)
      STYPE% = VAL(GET$#lun TO 44)
      RESERVE% = VAL(GET$#lun)
      
      CLOSE #lun
      
      
      PRINT"zmodeREGHI% = "; zmodeREGHI%
      PRINT"zmodeREGMID% = "; zmodeREGMID%
      PRINT"zmodeREGLO% = "; zmodeREGLO%
      PRINT"CHANNEL% = "; CHANNEL%
      PRINT"FILTER% = "; FILTER%
      PRINT"LOCAVERAGE% = "; LOCAVERAGE%
      PRINT"EXTCCODEL% = "; EXTCCODE%
      PRINT"BAUD% = "; BAUD%
      PRINT"COM$ = "; COM$
      PRINT"INPBUF% = "; INPBUF%
      PRINT"NUMAVG% = "; NUMAVG%
      PRINT"BU% = "; BU%
      PRINT"GAIN% = "; GAIN%
      PRINT"RATE = "; RATE
      PRINT"WL% = "; WL%
      PRINT"CHAN%(0) = "; CHAN%(0)
      PRINT"CHAN%(1) = "; CHAN%(1)
      PRINT"CHAN%(2) = "; CHAN%(2)
      PRINT"CHAN%(3) = "; CHAN%(3)
      PRINT"CHAN%(4) = "; CHAN%(4)
      PRINT"CHAN%(5) = "; CHAN%(5)
      PRINT"MYSINGLECHAN% = "; MYSINGLECHAN%
      PRINT"SCAN% = "; SCAN%
      PRINT"SCAN1% = "; SCAN1%
      PRINT"SCAN2% = "; SCAN2%
      PRINT"SCANINTERVAL# = "; SCANINTERVAL#
      PRINT"STYPE% = "; STYPE%
      IF LOCAVERAGE% = 0 THEN LOCAVERAGE% = 1
      IF FILTER% = 0 THEN FTIME# = 4.5
      IF FILTER% = 1 THEN FTIME# = 0.56
      IF FILTER% = 2 THEN FTIME# = 0.06
      DIM CC%(6)
      REM find number of active channels
      FOR N = 0 TO 5
        CC%(N) = CHAN%(N) MOD 16 - INT(CHAN%(N) / 16) + 1
        NUMCCS% = NUMCCS% + CC%(N)
      NEXT N
      REM Find Power of 2 of NUMAVG%
      Pof%=1
      (AGAIN)
      IF (NUMAVG% / 2 ^ Pof%) > 1 THEN Pof%= Pof% + 1 : GOTO (AGAIN)
      IF STYPE%=0 THEN NUMCCS%=1
      IF WL% = 0 THEN WORDCNT% = 2 ELSE WORDCNT% = 3
      zmodeREGHI% = zmodeREGHI% AND 254
      REM  clear powerdown bit
      SCALE24 = 5 / 2^24   : REM one count's worth for 5 volt range
      SCALE16 = 5 / 2^16   : REM one count's worth for 16 bit mode
      DIM BAUD$(6)
      BAUD$(0) ="9600" :BAUD$(1) = "4800" : BAUD$(2) ="2400" :BAUD$(3)  = "1200" :BAUD$(5) ="600" :BAUD$(5)  = "300"
  880 com_cmd$ = COM$ + " baud=" + BAUD$(BAUD%) + " parity=N data=8 stop=1 rts=off dtr=on xon=off octs=off idsr=off"
      REM prepare to wake
  900 OUTBYTE% = &0
  910 INPBYTE% = &0
  920 OUT$ = CHR$(OUTBYTE%)
      COM% = OPENUP(COM$ + " baud=300 parity=N data=8 stop=1 rts=off dtr=on xon=off octs=off idsr=off")
  940 PRINT"COM% = ";COM%
      IF COM% = 0 THEN PRINT "Could not open port ";COM$ : STOP
      PRINT"scan = 0, polled = 1 echotest = 2 ? ";
      Key$=GET$
      isPolledMode% = INT(VAL(Key$)) MOD 3
 1020 PRINT: PRINT "Signing on":
 1025 (WAKEUP)
 1035 WAIT 20 : IN$="0"
 1060 FOR loop = 1 TO 20
 1080   BPUT #COM%,OUT$;
        WAIT 20
        char%=EXT#COM%
        
 1090   IF char%> 0 THEN IN$ = GET$#COM% BY 1
        INPBYTE% = ASC(IN$)
 1110   IF db% THEN PRINT " IN$ = ";IN$; " ASC(IN$) = "; ASC(IN$);" INPBYTE% = ";INPBYTE%; " ";
        
 1120   IF INPBYTE% = 3 THEN
          WAIT 20
          GOTO EMPTYBUFFER
        ENDIF
        
      NEXT loop
      PRINT "Cant wake"
 1130 STOP
      
 1460 (EMPTYBUFFER)    : REM Be Certain "3" is last byte in buffer
      PRINT
 1470 IF db% THEN PRINT"chars in buffer = ";EXT#COM%
 1480 IF EXT#COM% > 0 THEN
 1490   IF db% THEN PRINT"GET char..."
 1500   GOSUB (GGETCHAR):
 1510   GOTO (EMPTYBUFFER)
 1520 ENDIF
 1530 IF INPBYTE% <> 3 THEN
        GOTO (WAKEUP)
      ELSE
        WAIT 20
      ENDIF
      
 1540 OUT$ = CHR$(&88)
      CHECKSUM% = 0
      REM send hex88
      BPUT#COM%, OUT$;
 1542 IF db% THEN PRINT "out$ ";  ASC(OUT$)
 1544 WAIT 10
 1550 OUT$ = CHR$(BAUD%)
      REM  send new baud rate
      BPUT#COM%, OUT$;
      IF db% THEN PRINT "sending BAUD ";  ASC(OUT$)
 1560 WAITIME = 2: NUMCHARS% = 1
      GOSUB (WAITCHAR)
      GOSUB (GGETCHAR)
 1570 IF INPBYTE% <> BAUD% THEN
        PRINT "baud not Echoed "; INPBYTE%, BAUD%, EXT#COM%
        GOTO (WAKEUP)
      ENDIF
      IF db% THEN PRINT "baud Echoed ";
 1580 CLOSE#COM%
      
 1600 REM  reopen COM port at new baud
      COM% = OPENUP(com_cmd$)
 1610 WAIT 10
      REM  WAIT .1 sec for power supply
      IF isPolledMode% = 2 THEN GOSUB (ECHOTEST)
      OUTBYTE%=0
 1620 OUT$ = CHR$(OUTBYTE%)
      BPUT#COM%, OUT$;
      IF db% THEN PRINT " Sending echo off ="; ASC(OUT$)
      REM  send A/D registers
 1630 GOSUB (SETzmode)
      REM  send avg. AND filt.
 1640 OUTB1% = Pof% : OUTB2% = FILTER%:
      GOSUB (SENDPACKET)
 1650 OUTB2% = isPolledMode%:
      IF db% THEN PRINT "set polled or scan mode"
      GOSUB (SENDPACKET)
 1660 GOSUB (DOREADZMODE)
      
      IF isPolledMode% = 1 THEN GOTO (poll)
      
      REM ######################
      REM ######################
      REM  start of scanning
      REM ######################
      REM ######################
      OUTB1% = SCAN%: OUTB2% = SCAN1%: GOSUB SENDPACKET
      OUTB1% = SCAN2%: OUTB2% = CHAN%(0): GOSUB SENDPACKET
      OUTB1% = CHAN%(1): OUTB2% = CHAN%(2): GOSUB SENDPACKET
      OUTB1% = CHAN%(3): OUTB2% = CHAN%(4): GOSUB SENDPACKET
      OUTB1% = CHAN%(5): OUTB2% = 0: GOSUB SENDPACKET
      
      WAIT 20
      
      (BEGIN):
      REM prepare to scan
      IF db% THEN PRINT "gosub (SCAL)"
      GOSUB (SCAL)
      
      IF STYPE% = 2 THEN
        SCANBYTES% = ((NUMCCS% + 2) * WORDCNT%) + 2
        OUTB1% = &8C
        REM calibrate scan token   &H8C
      ENDIF
      
      IF STYPE% = 1 THEN
        SCANBYTES% = (NUMCCS% * WORDCNT%) + 2
        OUTB1% = 137
        REM normal scan command token
      ENDIF
      
      IF STYPE% = 0 THEN
        SCANBYTES% = WORDCNT%
        REM singlechan has no start and end markers
        OUTB1% = 1
        REM OUTB2% = CHANSINGLE%
        OUTB2% = MYSINGLECHAN%
        REM set channel  was read from cfg
        GOSUB SENDPACKET
        WAIT 100
        OUTB1% = &8B
        REM single-channel scan token  &H8B
      ENDIF
      
      REM GoSub SENDPACKET here starts scan
      GOSUB SENDPACKET
      REM GET START SCAN TOKEN
      WAITIME= 1 : NUMCHARS%=1
      GOSUB WAITCHAR
      GOSUB GGETCHAR
      IF INPBYTE% <> OUTB1% THEN
        PRINT " Start Scan echo failure "
        END
      ENDIF
      NUMCHARS% = SCANBYTES%
      ENDSCANSENT%=0
      WAITIME = SCANINTERVAL# + .5
      
      REM ########################################
      REM ########################################
      REM (SCANSTATUS) used to check for scan data
      REM ########################################
      REM ########################################
      
      CLS
      PRINT "E to end scan   Esc to exit"
      (CHECK_SCAN_STATUS)
      
      IF EXT#COM% > (INPBUF% - 10) THEN
        PRINT "Buffer full"
        END
      ENDIF
      
      IF ENDSCANSENT% = 1 THEN
        XX= WAITIME * 100 : WAIT XX
        Chars% = EXT#COM%
        IF Chars% < NUMCHARS% THEN
          GOSUB GGETCHAR
          IF INPBYTE% <> &8A THEN
            PRINT "No ENDSCAN": END
          ELSE
            CLS: GOSUB (GGETCHKSUM)
            PRINT : PRINT "scan ended successfully"
            PRINT "P for Polled or other key to scan again: "
            Key$=GET$: SCANCNT=0: CLS
            IF FNupper(Key$) = "P" THEN GOTO (poll)
            GOTO (BEGIN)
          ENDIF
        ENDIF
      ENDIF
      GOSUB WAITCHAR
      REM wait for NUMCHARS%  or WAITIME
      SCANCNT = SCANCNT + 1
      PRINT "#"; SCANCNT;
      IF STYPE% <> 0 THEN
        GOSUB GGETCHAR
        IF INPBYTE% <> &F0 THEN
          PRINT "Scan framing failure (start of packet)
          END
        ENDIF
      ENDIF
      IF STYPE% = 2 THEN
        PRINT " Ofst";
        GOSUB GCONV
        OFFSET=VOLTS
        PRINT FNusing("    ##.######", OFFSET);
        PRINT "   FS";
        GOSUB GCONV
        VOLTS = VOLTS - OFFSET
        PRINT FNusing("   ##.######", VOLTS);
      ENDIF
      
      FOR N = 1 TO NUMCCS%
        GOSUB GCONV
        IF STYPE%=2 THEN  VOLTS=VOLTS-OFFSET
        PRINT FNusing("   ##.######", VOLTS);
      NEXT N
      
      REM should be end of scan token
      IF STYPE% <> 0 THEN
        GOSUB GGETCHAR
        IF INPBYTE% <> &F THEN
          PRINT "Scan framing failure (end of packet)" ; INPBYTE%
          END
        ENDIF
      ENDIF
      PRINT
      
      endScanKey$=INKEY$(0)
      IF FNupper(endScanKey$) = "E" THEN
        OUTB1% = &8A: GOSUB SENDPACKET
        ENDSCANSENT%=1
      ENDIF
      GOTO CHECK_SCAN_STATUS
      
      REM ********************************************
      REM       END OF SCANNING LOOP
      REM ********************************************
      
 1890 (SETCCODE)
 1900 OUTB1% = &1: OUTB2% = (CHANNEL% * 16) + EXTCCODE%
 1910 
 1920 (SENDPACKET):
      REM  send command, argument & checksum
 1930 
 1940 OUT$ = CHR$(OUTB1%)
      BPUT#COM%, OUT$;
      IF db% THEN  PRINT "B1 "; ASC(OUT$);
      OUT$ = CHR$(OUTB2%)
      BPUT#COM%, OUT$;
      IF db% THEN PRINT " B2 "; ASC(OUT$);
 1950 CHKSUM% = ((OUTB1% + OUTB2%) AND 255)
      OUT$ = CHR$(CHKSUM%)
      BPUT#COM%, OUT$;
      IF db% THEN PRINT " Checksum ";ASC(OUT$)
 1960 RETURN
 1970 
 1980 (GGETCHAR):    REM  fetch one byte from serial buffer
 1990 
 2000 INPBYTE% = 0
 2010 IF EXT#COM% > 0 THEN
        IN$ = GET$#COM% BY 1
 2040   INPBYTE% = ASC(IN$)
        CHECKSUM% = (CHECKSUM% + INPBYTE%) MOD 256
 2050 ENDIF
 2060 RETURN
 2080 
 2090 
 2100 (GGETCONV):    REM  request an A/D conversion
 2120 OUTB1% = &81
      GOSUB (SENDPACKET)
 2130 NUMCHARS% = WORDCNT% + 1
      GOSUB (WAITCHAR)
      GOSUB (GGETCHAR)
      IF INPBYTE% <> &81 THEN
        PRINT "no Get Conversion echo"
        END
      ENDIF
      
      REM  get an A/D conversion, calculate count and scale in volts
      (GCONV):
      GOSUB GGETCHAR
      BYTE1# = INPBYTE%
      
      GOSUB GGETCHAR
      BYTE2# = INPBYTE%
      IF WL% THEN
        GOSUB GGETCHAR
        BYTE3# = INPBYTE%
        Count# = BYTE1# + BYTE2# * 256 + BYTE3# * 65536
        VOLTS = (Count# * SCALE24)
      ELSE
        Count# = BYTE1# + BYTE2# * 256
        VOLTS = (Count# * SCALE16)
      ENDIF
      IF BU% = 0 THEN
        VOLTS = VOLTS * 2 - 5
      ENDIF
      RETURN
 2210 
 2220 (SCAL):    REM  perform system calibration
 2230 OORGAIN% = GAIN%
 2240 IF GAIN% <> 1 THEN
 2250   GAIN% = 1:
        GOSUB (WARMSTART)
 2260 ENDIF  : REM  IF gain not equal to 1, save original gain AND calibrate with GAIN 1
 2270 OORGCHAN% = CHANNEL%: CHANNEL% = 7: A$ = "O":
      GOSUB (DOCAL)
      REM  offset cal.
 2280 CHANNEL% = 6: A$ = "F":
      GOSUB (DOCAL)
      REM  full-scale cal.
 2290 IF GAIN% <> OORGAIN% THEN
        GAIN% = OORGAIN%
        GOSUB (WARMSTART)
        CHANNEL% = 7: A$ = "O"
        GOSUB (DOCAL)
      ENDIF
 2300 CHANNEL% = OORGCHAN%:
      REM  restore original channel
      GOSUB (SETCCODE)
 2310 XX = 100 * ((2 / RATE) + FTIME#):
      REM  WAIT for A/D to settle
      WAIT XX
 2320 RETURN
 2330 
 2340 (DOCAL):   REM  perform individual calibration on channel selected
 2350 
 2360 OUTB2% = (CHANNEL% * 16) + EXTCCODE%
 2370 OORGW = WAITIME
      WAITIME = FTIME# + 4
 2380 IF A$ = "O" THEN OUTB1% = &82: IF db% THEN PRINT"Offset Calibration    ";
 2390 IF A$ = "F" THEN OUTB1% = &83: IF db% THEN PRINT"Full-scale Calibration";
 2400 GOSUB (SENDPACKET): NUMCHARS% = WORDCNT% + 1
      GOSUB (WAITCHAR)
 2410 FOR I = 1 TO  NUMCHARS%
        GOSUB (GGETCHAR)
        IF db% THEN PRINT " Cal ";INPBYTE%;
      NEXT
      WAITIME = OORGW
 2420 RETURN
 2430 
 2440 (SETzmode):
      REM  send mode registers
 2450 
 2460 OUTB1% = zmodeREGHI%
      OUTB2% = zmodeREGMID%
      GOSUB (SENDPACKET)
 2470 OUTB1% = zmodeREGLO%
      GOSUB (SENDPACKET)
 2480 RETURN
 2490 
 2500 (WAITCHAR)
      REM  wait WAITIME seconds for NUMCHARS% characters
 2510 TEMPWAIT = WAITIME * 100
 2520 YY = TIME + TEMPWAIT
 2530 
 2540 (HOLDON)
      Chars% = EXT#COM%
 2560 IF Chars% >= NUMCHARS% THEN
        RETURN
      ENDIF
 2570 IF TIME < YY THEN
        GOTO (HOLDON)
      ELSE
        PRINT " Serial port time-out"
        END
      ENDIF
 2580 RETURN
 2590 
 2720 (WARMSTART)
      REM  re-start after zmode change
 2730 
 2740 OUTB1% = &84: GOSUB (SENDPACKET): WAIT 10
      NUMCHARS% = 1: GOSUB (WAITCHAR)
      zmodeREGHI% = ((GAIN%-1) * 4)
      GOSUB (SETzmode)
 2750 GOSUB (GGETCHAR)
      IF INPBYTE% <> &84 THEN
        PRINT "warmstart echo failed "
        END
      ENDIF
      
 2760 (DOREADZMODE):
      IF db% THEN PRINT "entering DOREADZMODE"
      REM  verify zmode registers were properly read
 2770 NUMCHARS% = 3:  WAITIME=2
      GOSUB (WAITCHAR)
 2780 GOSUB (GGETCHAR):
      IF (INPBYTE% AND &1F) <> (zmodeREGHI% AND &1F) THEN
        PRINT "RegHI";  (zmodeREGHI% AND &1F),
        PRINT "inpbyte "; (INPBYTE% AND &1F) : STOP
      ENDIF
 2790 GOSUB (GGETCHAR):
      IF INPBYTE% <> zmodeREGMID% THEN
        PRINT "RegMID";  zmodeREGMID%,
        PRINT "inpbyte "; INPBYTE%  : STOP
      ENDIF
 2800 GOSUB (GGETCHAR):
      IF INPBYTE% <> zmodeREGLO% THEN
        PRINT "RegLO";  zmodeREGLO%,
        PRINT "inpbyte "; INPBYTE%  : STOP
      ENDIF
 2810 RETURN
 2820 
      REM for troubleshooting only, prints buffer contents
 2900 NUMCHARS% = 1:  WAITIME=2
      GOSUB (WAITCHAR)
      GOSUB (GGETCHAR)
      PRINT " ";INPBYTE%;
      GOTO 2900
      
 3000 REM running Checksum
      (GGETCHKSUM)
      OUTB1% = &87
      OUTB2% = 1
      GOSUB SENDPACKET
      NUMCHARS% = 2: GOSUB WAITCHAR
      GOSUB (GGETCHAR)
      IF (OUTB1% <> INPBYTE%) THEN
        PRINT "Checksum token echo wrong "
      ENDIF
      GOSUB (GGETCHAR)
      IF CHECKSUM% <> ((INPBYTE% + INPBYTE%) MOD 256) THEN
        PRINT " M201 checksum (HEX) "; INPBYTE%;
        PRINT " LOCAL checksum (HEX) "; CHECKSUM%;
        PRINT "  Checksum NG ";
        STOP
      ENDIF
      PRINT TAB(3,9) "Checksum OK";
      CHECKSUM% = 0
      RETURN
      
      REM Data requests
      (Ver)
      OUTB1% = &86 : GOTO (Sendit)
      (DigIn)
      OUTB1% = &80
      (Sendit)
      OUTB2% = &4C
      GOSUB SENDPACKET
      NUMCHARS% = 2: GOSUB WAITCHAR
      GOSUB (GGETCHAR)
      IF (OUTB1% <> INPBYTE%) THEN
        PRINT "Command token echo wrong "
      ENDIF
      GOSUB (GGETCHAR)
      RETURN
      
      REM ########################################
      REM ########################################
      REM (poll) start of polled loop
      REM ########################################
      REM ########################################
      (poll)
      DIM CNT#(LOCAVERAGE%)
      WAITIME = 2
      REM  calibrate before displaying data
      GOSUB (SCAL)
      (POLL1):
      REM  GET conversions, scale in volts and display
      CLS
      PRINT "K= checKsum   C= Control code   V= Version   D= Digital in   U=digital oUt   E= Exit"
      PRINT
      PRINT "     Chan="; CHANNEL%; "   Ext="; EXTCCODE%
      PRINT
      GOSUB (GGETCONV)
      
      CNTTOT# = LOCAVERAGE% * Count#  : REM  for local averaging only
      FOR N = 0 TO LOCAVERAGE% - 1: CNT#(N)= Count#: NEXT
      CNTPTR%=0
      
      (POLLOOP)
      GOSUB (GGETCONV)
      PRINT TAB(5,5) FNusing(" COUNT   ##,###,###", Count#);
      PRINT FNusing("       VOLTS     ##.######", VOLTS)
      IF LOCAVERAGE% > 1 THEN
        CNTTOT# = CNTTOT# + Count# - CNT#(CNTPTR%)
        CNT#(CNTPTR%) = Count#
        CNTPTR%= (CNTPTR% + 1) MOD LOCAVERAGE%
        AVGCnt# = CNTTOT#/LOCAVERAGE%
        IF WL% THEN
          AVGV = (AVGCnt# * SCALE24)
        ELSE
          AVGV = (AVGCnt# * SCALE16)
        ENDIF
        IF BU% = 0 THEN AVGV = AVGV * 2 - 5
        
        CNTTOT# = CNTTOT# + Count# - CNT#(CNTPTR%)
        CNT#(CNTPTR%) = Count#
        CNTPTR%= (CNTPTR% + 1) MOD LOCAVERAGE%
        
        PRINT FNusing("      AVGCNT  ##,###,###", AVGCnt#);
        PRINT FNusing("       AVGVOLTS  ##.######", AVGV)
      ENDIF
      A$ = FNupper(INKEY$(1))
      IF A$ = "" THEN GOTO (POLLOOP)
      IF A$ = "E" THEN END
      IF A$="V" GOSUB (Ver): PRINT TAB(28,1) INPBYTE%
      IF A$="D" THEN
        GOSUB (DigIn) : PRINT TAB(48,1);
        FOR NN% = 7 TO 0 STEP -1
          IF INPBYTE% AND 2 ^ NN% THEN PRINT "1";  ELSE PRINT "0";
        NEXT NN%
      ENDIF
      IF A$="K" GOSUB (GGETCHKSUM)
      IF A$="U" GOSUB (DigOut) : GOTO (POLL1)
      IF A$="C" GOSUB (CHANGECHAN) : GOTO (POLL1)
      GOTO (POLLOOP)
      
      (CHANGECHAN)
      PRINT TAB(7,3)"Enter control code:  CHANNEL% * 16 + EXTCCODE% ";
      INPUT LINE Key$
      CH%= VAL(Key$) MOD 128
      CHANNEL%= INT(CH%/16)
      EXTCCODE%= CH%- CHANNEL% * 16
      GOSUB (SETCCODE)
      RETURN
      
      (DigOut)
      PRINT TAB(7,3)"Enter Digital output word  ";
      INPUT LINE Key$
      OUTB1%=  2
      OUTB2%= VAL(Key$) MOD 256
      GOSUB (SENDPACKET)
      RETURN
      
      
      (ECHOTEST)
      CLS
      NUMCHARS% = 1:  WAITIME=.2
      PRINT "Echo Testing "
      PRINT "End test with 0 for scanning or 1 for Polled Mode ";
      (ET1)
      OUTBYTE%= ((OUTBYTE%+1) MOD 255 ) + 1
      OUT$ = CHR$(OUTBYTE%)
      BPUT #COM%,OUT$;
      GOSUB (WAITCHAR)
      GOSUB (GGETCHAR)
      PRINT TAB(4, 4) INPBYTE%
      IF  INPBYTE% <> OUTBYTE% THEN
        PRINT "Echo error"
        END
      ENDIF
      A$ = FNupper(INKEY$(1))
      IF A$ = "" THEN GOTO (ET1)
      IF A$ = "0" THEN
        isPolledMode% = 0
      ELSE
        isPolledMode% = 1
      ENDIF
      RETURN
      
      
